<?
	include "utils.php";
	include "config.php";
	set_time_limit(0);

	function genUsage($filename,$mode) // generate possible abuse usage report
	{
		include "country_code.php";
		$fpath = generateLogPath($filename);
		$total_input_size = 0; // total input traffic in bytes
		$total_output_size = 0; // total input traffic in bytes
		$date_range = array();
		$dns_cache = array();
		$users_ip_usage_count = array();
		$users_ip_list = array();
		$last_seen_onsite = array();
		$stime = time();
		$lines = file($fpath);
		$linecount = 0;
		if(isset($_SESSION['dns_cache']))
			$dns_cache_session = $_SESSION['dns_cache'];
		foreach($lines as $line_num => $line)
		{
			$linecount++;
			$line = trim($line);
			$tokens = csv_explode(" ",$line);
			$vald = substr($tokens[3],0,10);
			if(isset($_REQUEST['dateselbox_s']) == true && $_REQUEST['dateselbox_s'] != "")
				$start_date = $_REQUEST['dateselbox_s'];
			if(isset($_REQUEST['dateselbox_e']) == true && $_REQUEST['dateselbox_e'] != "")
				$end_date = $_REQUEST['dateselbox_e'];
			if(($vald >= $start_date && $vald <= $end_date) || (isset($start_date) == false && isset($end_date) == false))
			{
				$current_username = $tokens[1]; // username
				$garray = explode(",",$tokens[2]);
				if(count($garray) > 1)
					$current_group = $garray[0];  // group
				else
					$current_group = $tokens[2];  // group
				if($tokens[4] == "w" || $tokens[4] == "r" || $tokens[4] == "l" || $tokens[4] == "e" || $tokens[4] == "m" || $tokens[4] == "d" || $tokens[4] == "s")
				{
						if(isset($users_ip_list[$current_username]) == false)
						{
							$users_ip_usage_count[$current_username] = 1;
							$users_ip_list[$current_username] = array(1 => $tokens[0]); // must start from 1 index -- warning
						}
						else
						{
							$tmparr  = $users_ip_list[$current_username];
							if(array_search($tokens[0],$tmparr) == false)
							{
								array_push($tmparr,$tokens[0]);
								$users_ip_usage_count[$current_username] = count($tmparr);
								$users_ip_list[$current_username] = $tmparr;
							}
						}
				}
			}
		}
		$etime = time();
		$str_lines               = "Total lines in LOG file: " . $linecount;
		$str_time_taken          = "Time taken for analysis: " . ($etime - $stime) . " second(s)";
		$str_size_logfile        = "Size of LOG file: " . byte_format(filesize($fpath));
		echo '<div class="info">';
		echo $str_lines; echo "<br>";
		echo $str_time_taken; echo "<br>";
		echo $str_size_logfile; echo "<br>";
		echo '</div>';
		echo "<h2>The IP addresses being used by each user</h2>";
		$counter = 0;
		arsort($users_ip_usage_count);
		echo '<table id="grid1" class="grid" border=0 cellspacing=0 cellpadding=0><thead><tr><td width=50>No.</td><td width=120>Username</td><td width=120>IP addr.</td><td>Host name</td><td>Country</td></tr></thead><tbody>';
		foreach($users_ip_usage_count as $key => $val)
		{
			$counter++;
			if($counter == 1 || $counter == 2 || $counter == 3)
				$itag = "<div class='medal$counter'></div>";
			else
				$itag = "<div class='rank'>$counter</div>";
			if($val <= 1)
				$ipk = "IP";
			else
				$ipk = "IPs";
			echo "<tr><td>$itag</td><td><div class='path'>$key" . "@" . $val . " $ipk</div></td><td>-</td><td>-</td><td>-</td></tr>";
			asort($users_ip_list[$key]);
			foreach($users_ip_list[$key] as $key2 => $val2)
			{
				if(isPrivateIP($val2) == false)
				{
					if(isset($dns_cache_session))
					{
						if(isset($dns_cache_session[$val2]))
							$r_hostname = $dns_cache_session[$val2];
						else
							$r_hostname = gethostbyaddr($val2);
					}
					else
						$r_hostname = gethostbyaddr($val2);
				}
				else
					$r_hostname = "Intranet";
				$dns_cache[$val2] = $r_hostname;
				$dmarr = explode(".",$r_hostname);
				$dma = "-";
				if(count($dmarr) > 1)
				{
					$lastcnt = count($dmarr) - 1;
					$lastdm = $dmarr[$lastcnt];
					if(isset($countrycode[$lastdm]) == true)
						$dma = $countrycode[$lastdm];
				}
				echo "<tr><td>&nbsp;</td><td><div class='path'>&nbsp;</div></td><td>$val2</td><td>$r_hostname</td><td>$dma</td></tr>";
			}
		}
		echo '</tbody></table>';
		if(isset($_SESSION['dns_cache']) == false)
			$_SESSION['dns_cache'] = $dns_cache;
		else
			$_SESSION['dns_cache'] = array_merge($_SESSION['dns_cache'],$dns_cache);

	}

	function generateLogPath($filename)
	{
		global $rdnpath;
		if(isFilenameSecure($filename) == false)
			die("Invalid filename");
		$ext = getFileType($filename);
		if($ext != "log")
			die("Not a LOG file");
		$fpath = $rdnpath . "\\log\\" . $filename;
		if(file_exists($fpath) == true)
			return $fpath;
		else
			die("invalid log file path");
	}

	function genLogList($filename,$mode)
	{
		$keyword = "e";
		if($mode == 6)
			$keyword = "e";
		else if($mode == 7)
			$keyword = "d";
		else if($mode == 8)
			$keyword = "s";
		else if($mode == 9)
			$keyword = "l";
		else if($mode == 10)
			$keyword = "m";
		else if($mode == 11)
			$keyword = "w";
		else if($mode == 12)
			$keyword = "r";
		$fpath = generateLogPath($filename);
		$date_range = array();
		$errorsArray = array();
		$stime = time();
		$lines = file($fpath);
		$linecount = 0;
		$ecount = 0;
		foreach($lines as $line_num => $line)
		{
			$linecount++;
			$line = trim($line);
			$tokens = csv_explode(" ",$line);
			$vald = substr($tokens[3],0,10);
			if(isset($_REQUEST['dateselbox_s']) == true && $_REQUEST['dateselbox_s'] != "")
				$start_date = $_REQUEST['dateselbox_s'];
			if(isset($_REQUEST['dateselbox_e']) == true && $_REQUEST['dateselbox_e'] != "")
				$end_date = $_REQUEST['dateselbox_e'];
			if(($vald >= $start_date && $vald <= $end_date) || (isset($start_date) == false && isset($end_date) == false))
			{
				if($tokens[4] == $keyword) // extract log entries
				{
						$errorsArray[$ecount] = $line;
						$ecount++;
				}
			}
		}
		$etime = time();
		echo '<div class="info">';
		$str_lines               = "Total lines in LOG file: " . $linecount;
		$str_time_taken          = "Time taken for analysis: " . ($etime - $stime) . " second(s)";
		$str_size_logfile        = "Size of LOG file: " . byte_format(filesize($fpath));
		echo $str_lines; echo "<br>";
		echo $str_size_logfile; echo "<br>";
		echo '</div>';
		$counter = 0;
		echo "<BR>";
		$totalecount = count($errorsArray);
		if($mode == 7 || $mode == 10)
		{
			echo '<table id="grid1" class="grid" border=0 cellspacing=0 cellpadding=0><thead><tr><td width=50>No.</td><td width=120>IP addr.</td><td>Username</td><td>Date&Time</td><td>Path</td></tr></thead><tbody>';
			for($i=1;$i<=$totalecount;$i++)
			{
				$counter++;
				$thiscount = $totalecount - $i;
				$tokens = csv_explode(" ",$errorsArray[$thiscount]);
				echo "<tr><td>$counter</td><td>$tokens[0]</td><td title='group: " . $tokens[2] . "'>$tokens[1]</td><td>$tokens[3]</td><td>$tokens[5]</td></tr>\n";
				if($i >= 1000)
					break;
			}
			echo '</tbody></table>';
		}
		else if($mode == 9)
		{
			echo '<table id="grid1" class="grid" border=0 cellspacing=0 cellpadding=0><thead><tr><td width=50>No.</td><td width=120>IP addr.</td><td>Username</td><td>Date&Time</td><td>Information</td></tr></thead><tbody>';
			for($i=1;$i<=$totalecount;$i++)
			{
				$counter++;
				$thiscount = $totalecount - $i;
				$tokens = csv_explode(" ",$errorsArray[$thiscount]);
				echo "<tr><td>$counter</td><td>$tokens[0]</td><td title='group: " . $tokens[2] . "'>$tokens[1]</td><td>$tokens[3]</td><td>$tokens[5]</td></tr>\n";
				if($i >= 1000)
					break;
			}
			echo '</tbody></table>';
		}
		else if($mode == 8)
		{
			echo '<table id="grid1" class="grid" border=0 cellspacing=0 cellpadding=0><thead><tr><td width=50>No.</td><td width=120>IP addr.</td><td>Username</td><td>Date&Time</td><td>Command line</td></tr></thead><tbody>';
			for($i=1;$i<=$totalecount;$i++)
			{
				$counter++;
				$thiscount = $totalecount - $i;
				$tokens = csv_explode(" ",$errorsArray[$thiscount]);
				echo "<tr><td>$counter</td><td>$tokens[0]</td><td title='group: " . $tokens[2] . "'>$tokens[1]</td><td>$tokens[3]</td><td>$tokens[5]</td></tr>\n";
				if($i >= 1000)
					break;
			}
			echo '</tbody></table>';
		}
		else if($mode == 6)
		{
			echo '<table id="grid1" class="grid" border=0 cellspacing=0 cellpadding=0><thead><tr><td width=50>No.</td><td width=120>IP addr.</td><td>Username</td><td>Date&Time</td><td>Error</td></tr></thead><tbody>';
			for($i=1;$i<=$totalecount;$i++)
			{
				$counter++;
				$thiscount = $totalecount - $i;
				$tokens = csv_explode(" ",$errorsArray[$thiscount]);
				echo "<tr><td>$counter</td><td>$tokens[0]</td><td title='group: " . $tokens[2] . "'>$tokens[1]</td><td>$tokens[3]</td><td>$tokens[5]</td></tr>\n";
				if($i >= 1000)
					break;
			}
			echo '</tbody></table>';
		}
		else
		{
			echo '<table id="grid1" class="grid" border=0 cellspacing=0 cellpadding=0><thead><tr><td width=50>No.</td><td width=120>IP addr.</td><td>Username</td><td>Date&Time</td><td>Path</td><td>Size</td><td>Speed (kb/s)</td></tr></thead><tbody>';
			for($i=1;$i<=$totalecount;$i++)
			{
				$counter++;
				$thiscount = $totalecount - $i;
				$tokens = csv_explode(" ",$errorsArray[$thiscount]);
				echo "<tr><td>$counter</td><td>$tokens[0]</td><td title='group: " . $tokens[2] . "'>$tokens[1]</td><td>$tokens[3]</td><td>$tokens[5]</td><td>" . byte_format($tokens[6]) . "</td><td>$tokens[7]</td></tr>\n";
				if($i >= 1000)
					break;
			}
			echo '</tbody></table>';
		}
	}

	function genTrafficGraph($filename)
	{
		$fpath = generateLogPath($filename);
		$total_input_size = 0; // total input traffic in bytes
		$total_output_size = 0; // total input traffic in bytes
		$average_input_speed = 0; // average output speed in kb/s
		$average_output_speed = 0; // average output speed in kb/s
		$num_of_logins = 0; // login attempt count
		$num_of_ips    = 0; // login ip count
		$tmp_w_counter = 0;
		$tmp_w_spd_sum = 0;
		$tmp_r_counter = 0;
		$tmp_r_spd_sum = 0;
		$ip_range = array();
		$date_range = array();
		$datehour_traffic_o = array(); // output date and hour traffic data
		$datehour_traffic_i = array(); // input date and hour traffic data
		$datehour_spd_o = array(); // output date and hour speed data
		$datehour_spd_i = array(); // input date and hour speed data
		$stime = time();
		$lines = file($fpath);
		$linecount = 0;
		foreach($lines as $line_num => $line)
		{
			$linecount++;
			$line = trim($line);
			$tokens = csv_explode(" ",$line);
			if($tokens[4] == "w") // input traffic
			{
				if(count($tokens) == 8)
				{
					if(is_numeric($tokens[6])) // output size in bytes
					{
						$total_input_size = $total_input_size + $tokens[6];
						//echo "Line #<b>{$line_num}</b> : " . htmlspecialchars($line) . ">" . $tokens[7] . "<br>\n";
					}
					if(is_numeric($tokens[7])) // check speed field
					{
						$tmp_w_spd_sum = $tmp_w_spd_sum + $tokens[7];
						$tmp_w_counter++;
					}
					$date1 = substr($tokens[3],0,10);
					$hour1 = substr($tokens[3],11,2);
					// generate traffic 24 hr data
					if(isset($datehour_traffic_i[$date1][$hour1]))
						$datehour_traffic_i[$date1][$hour1] = $datehour_traffic_i[$date1][$hour1] + $tokens[6];
					else
						$datehour_traffic_i[$date1][$hour1] = $tokens[6];
					// generate avg speed 24 hr data
					if(isset($datehour_spd_i[$date1][$hour1]))
						$datehour_spd_i[$date1][$hour1] = ($datehour_spd_i[$date1][$hour1] + $tokens[7]) / 2;
					else
						$datehour_spd_i[$date1][$hour1] = $tokens[7];
					if(isset($date_range[$date1]) == false) // there is traffic in this day
						$date_range[$date1] = $date1;
				}
			}
			else if($tokens[4] == "r") // input traffic
			{
				if(count($tokens) == 8)
				{
					if(is_numeric($tokens[6])) // output size in bytes
					{
						$total_output_size = $total_output_size + $tokens[6];
						//echo "Line #<b>{$line_num}</b> : " . htmlspecialchars($line) . ">" . $tokens[7] . "<br>\n";
					}
					if(is_numeric($tokens[7])) // check speed field
					{
						$tmp_r_spd_sum = $tmp_r_spd_sum + $tokens[7];
						$tmp_r_counter++;
					}
					$date1 = substr($tokens[3],0,10);
					$hour1 = substr($tokens[3],11,2);
					if(isset($datehour_traffic_o[$date1][$hour1]))
						$datehour_traffic_o[$date1][$hour1] = $datehour_traffic_o[$date1][$hour1] + $tokens[6];
					else
						$datehour_traffic_o[$date1][$hour1] = $tokens[6];
					if(isset($datehour_spd_o[$date1][$hour1]))
						$datehour_spd_o[$date1][$hour1] = ($datehour_spd_o[$date1][$hour1] + $tokens[7]) / 2;
					else
						$datehour_spd_o[$date1][$hour1] = $tokens[7];
					if(isset($date_range[$date1]) == false) // there is traffic in this day
						$date_range[$date1] = $date1;
				}
			}
			else if($tokens[4] == "l") // login attempt
			{
				$num_of_logins++;
			}
			$ips = $tokens[0];
			if(isset($ip_range[$ips]) == false)
				$ip_range[$ips] = 1;
			else
				$ip_range[$ips] = $ip_range[$ips] + 1;
		}
		$etime = time();
		$str_lines               = "Total number of lines in LOG file: " . $linecount;
		$str_time_taken          = "Time taken for analysis: " . ($etime - $stime) . " second(s)";
		$str_size_logfile        = "LOG file size: " . byte_format(filesize($fpath));
		$str_total_upload_size   = "Total upload size: " . byte_format($total_input_size);
		$str_avg_upload_spd      = "Averge upload speed: " . sprintf("%.2f",$tmp_w_spd_sum/$tmp_w_counter) . " kbyte(s)/sec";
		$str_total_download_size = "Total download size: " . byte_format($total_output_size);
		$str_avg_download_spd    = "Averge download speed: " . sprintf("%.2f",$tmp_r_spd_sum/$tmp_r_counter) . " kbyte(s)/sec";
		$str_num_logins          = "Number of login attempts: " . $num_of_logins;
		$str_num_ip_origins      = "Total number of distinct IP addresses: " . count($ip_range);
		$str_most_active_ip      = "";
		arsort($ip_range);
		foreach($ip_range as $key => $val)
		{
			$str_most_active_ip      =  "Most active IP addr.: " . $key;
			break;
		}
		echo "<div class='info'><p>" . $str_lines; echo "<br>";
		echo $str_time_taken; echo "<br>";
		echo $str_size_logfile; echo "<br>";
		echo $str_num_logins; echo "<br>";
		echo $str_num_ip_origins; echo "<br>";
		echo $str_most_active_ip; echo "<br>";
		echo $str_total_upload_size; echo "<br>";
		echo $str_avg_upload_spd; echo "<br>";
		echo $str_total_download_size; echo "<br>";
		echo $str_avg_download_spd; echo "</p>";
		asort($date_range); // old date first
		if(isset($_REQUEST['dateselbox_s']) == true && $_REQUEST['dateselbox_s'] != "")
			$start_date = $_REQUEST['dateselbox_s'];
		if(isset($_REQUEST['dateselbox_e']) == true && $_REQUEST['dateselbox_e'] != "")
			$end_date = $_REQUEST['dateselbox_e'];
		foreach($date_range as $key => $val)
		{
			if(($val >= $start_date && $val <= $end_date) || (isset($start_date) == false && isset($end_date) == false))
			{
				$param_out = "";
				$param_in = "";
				echo "<h2>The net traffic of $val" . "</h2>\n";
				for($i=0;$i<24;$i++)
				{
					$khour = sprintf("%02d",$i);
					if(isset($datehour_traffic_o[$val][$khour]))
					{
					//	echo $khour . ": " . $datehour_traffic_o[$val][$khour] . ",";
						$param_out = $param_out . $khour . ":" . $datehour_traffic_o[$val][$khour] . ",";
					}
				}
				//echo "<p>UL:</p>\n";
				for($i=0;$i<24;$i++)
				{
					$khour = sprintf("%02d",$i);
					if(isset($datehour_traffic_i[$val][$khour]))
					{
					//	echo $khour . ": " . $datehour_traffic_i[$val][$khour] . ",";
						$param_in = $param_in . $khour . ":" . $datehour_traffic_i[$val][$khour] . ",";
					}
				}
				echo "<center><img width=480 height=360 src='" . "operate.php?op=trafficchart&param1=" . $param_out . "&param2=" . $param_in  . "&param3=" . $key . "'></center>";
				echo "<h2>The average speed of U/L and D/L on $val" . "</h2>\n";
				$param_out = "";
				$param_in = "";
				for($i=0;$i<24;$i++)
				{
					$khour = sprintf("%02d",$i);
					if(isset($datehour_spd_o[$val][$khour]))
					{
						// echo $khour . ": " . $datehour_spd_o[$val][$khour] . ",";
						$param_out = $param_out . $khour . ":" . $datehour_spd_o[$val][$khour] . ",";
					}
				}
				// echo "<p>UL:</p>\n";
				for($i=0;$i<24;$i++)
				{
					$khour = sprintf("%02d",$i);
					if(isset($datehour_spd_i[$val][$khour]))
					{
						// echo $khour . ": " . $datehour_spd_i[$val][$khour] . ",";
						$param_in = $param_in . $khour . ":" . $datehour_spd_i[$val][$khour] . ",";
					}
				}
				echo "<center><img width=480 height=360 src='" . "operate.php?op=spdchart&param1=" . $param_out . "&param2=" . $param_in  . "&param3=" . $key . "'></center>";
			}
		}
		echo "</div>";
	}

	function genTopstatistics($filename)
	{
		$fpath = generateLogPath($filename);
		$total_input_size = 0; // total input traffic in bytes
		$total_output_size = 0; // total input traffic in bytes
		$date_range = array();
		$user_to_group_map = array();
		$user_upload_bytes = array();
		$user_download_bytes = array();
		$group_upload_bytes = array();
		$group_download_bytes = array();
		$user_upload_hits = array();
		$user_download_hits = array();
		$group_upload_hits = array();
		$group_download_hits = array();
		$stime = time();
		$lines = file($fpath);
		$linecount = 0;
		foreach($lines as $line_num => $line)
		{
			$linecount++;
			$line = trim($line);
			$tokens = csv_explode(" ",$line);
			$vald = substr($tokens[3],0,10);
			if(isset($_REQUEST['dateselbox_s']) == true && $_REQUEST['dateselbox_s'] != "")
				$start_date = $_REQUEST['dateselbox_s'];
			if(isset($_REQUEST['dateselbox_e']) == true && $_REQUEST['dateselbox_e'] != "")
				$end_date = $_REQUEST['dateselbox_e'];
			if(($vald >= $start_date && $vald <= $end_date) || (isset($start_date) == false && isset($end_date) == false))
			{
				$current_username = $tokens[1]; // username
				$garray = explode(",",$tokens[2]);
				if(count($garray) > 1)
					$current_group = $garray[0];  // group
				else
					$current_group = $tokens[2];  // group
				$user_to_group_map[$current_username] = $current_group;
				if($tokens[4] == "w") // make top uploaders
				{
					if(count($tokens) == 8)
					{
						if(is_numeric($tokens[6])) // input size in bytes
						{
							$total_input_size = $total_input_size + $tokens[6];
							if(isset($user_upload_bytes[$current_username]) == false)
								$user_upload_bytes[$current_username] = $tokens[6];
							else
								$user_upload_bytes[$current_username] = $user_upload_bytes[$current_username] + $tokens[6];
							if(isset($group_upload_bytes[$current_group]) == false)
								$group_upload_bytes[$current_group] = $tokens[6];
							else
								$group_upload_bytes[$current_group] = $group_upload_bytes[$current_group] + $tokens[6];
						}
					}
				}
				else if($tokens[4] == "r") // input traffic
				{
					if(count($tokens) == 8)
					{
						if(is_numeric($tokens[6])) // output size in bytes
						{
							$total_output_size = $total_output_size + $tokens[6];
							if(isset($user_download_bytes[$current_username]) == false)
								$user_download_bytes[$current_username] = $tokens[6];
							else
								$user_download_bytes[$current_username] = $user_download_bytes[$current_username] + $tokens[6];
							if(isset($group_download_bytes[$current_group]) == false)
								$group_download_bytes[$current_group] = $tokens[6];
							else
								$group_download_bytes[$current_group] = $group_download_bytes[$current_group] + $tokens[6];
						}
					}
				}
			}
		}
		$etime = time();
		$str_lines               = "Total lines in LOG file: " . $linecount;
		$str_time_taken          = "Time taken for analysis: " . ($etime - $stime) . " second(s)";
		$str_size_logfile        = "Size of LOG file: " . byte_format(filesize($fpath));
		$str_total_upload_size   = "Total input size: " . byte_format($total_input_size);
		$str_total_download_size = "Total output size: " . byte_format($total_output_size);
		echo '<div class="info">';
		echo $str_lines; echo "<br>";
		echo $str_time_taken; echo "<br>";
		echo $str_size_logfile; echo "<br>";
		echo $str_total_upload_size; echo "<br>";
		echo $str_total_download_size; echo "<br>";
		echo '</div>';
		arsort($user_upload_bytes);
		$counter = 0;
		echo "<h2>Top uploaders by size</h2>";
		echo '<table id="grid1" class="grid" border=0 cellspacing=0 cellpadding=0><thead><tr><td width=50>No.</td><td width=120>Username</td><td width=120>Group</td><td>Xfer size</td><td>Percentage</td></tr></thead><tbody>';
		foreach($user_upload_bytes as $key => $val)
		{
			$counter++;
			if($counter == 1 || $counter == 2 || $counter == 3)
				$itag = "<div class='medal$counter'></div>";
			else
				$itag = "<div class='rank'>$counter</div>";
		  echo "<tr><td>$itag</td><td>$key</td><td>" . $user_to_group_map[$key] . "</td><td>" . byte_format($val) . "</td><td>" . round($val/$total_input_size,4)*100 . "%</td></tr>";
		}
		echo '</tbody></table>';
		arsort($user_download_bytes);
		$counter = 0;
		echo "<h2>Top downloaders by size</h2>";
		echo '<table id="grid2" class="grid" border=0 cellspacing=0 cellpadding=0><thead><tr><td width=50>No.</td><td width=120>Username</td><td width=120>Group</td><td>Xfer size</td><td>Percentage</td></tr></thead><tbody>';
		foreach($user_download_bytes as $key => $val)
		{
			$counter++;
			if($counter == 1 || $counter == 2 || $counter == 3)
				$itag = "<div class='medal$counter'></div>";
			else
				$itag = "<div class='rank'>$counter</div>";
		  echo "<tr><td>$itag</td><td>$key</td><td>" . $user_to_group_map[$key] . "</td><td>" . byte_format($val) . "</td><td>" . round($val/$total_output_size,4)*100 . "%</td></tr>";
		}
		echo '</tbody></table>';
		arsort($group_upload_bytes);
		$counter = 0;
		echo "<h2>Top uploading groups by size</h2>";
		echo '<table id="grid3" class="grid" border=0 cellspacing=0 cellpadding=0><thead><tr><td width=50>No.</td><td width=120>Group</td><td>Xfer size</td><td>Percentage</td></tr></thead><tbody>';
		foreach($group_upload_bytes as $key => $val)
		{
			$counter++;
			if($counter == 1 || $counter == 2 || $counter == 3)
				$itag = "<div class='medal$counter'></div>";
			else
				$itag = "<div class='rank'>$counter</div>";
		  echo "<tr><td>$itag</td><td>$key</td><td>" . byte_format($val) . "</td><td>" . round($val/$total_input_size,4)*100 . "%</td></tr>";
		}
		echo '</tbody></table>';
		arsort($group_download_bytes);
		$counter = 0;
		echo "<h2>Top downloading groups by size</h2>";
		echo '<table id="grid4" class="grid" border=0 cellspacing=0 cellpadding=0><thead><tr><td width=50>No.</td><td width=120>Group</td><td>Xfer size</td><td>Percentage</td></tr></thead><tbody>';
		foreach($group_download_bytes as $key => $val)
		{
			$counter++;
			if($counter == 1 || $counter == 2 || $counter == 3)
				$itag = "<div class='medal$counter'></div>";
			else
				$itag = "<div class='rank'>$counter</div>";
		  echo "<tr><td>$itag</td><td>$key</td><td>" . byte_format($val) . "</td><td>" . round($val/$total_output_size,4)*100 . "%</td></tr>";
		}
		echo '</tbody></table>';
	}

	function queryDateRange($filename)
	{
		$fpath = generateLogPath($filename);
		$date_range = array();
		$lines = file($fpath);
		foreach($lines as $line_num => $line)
		{
			$line = trim($line);
			$tokens = csv_explode(" ",$line);
			if($tokens[4] == "w" || $tokens[4] == "r")
			{
				if(count($tokens) == 8)
				{
					$date1 = substr($tokens[3],0,10);
					if(isset($date_range[$date1]) == false) // there is traffic in this day
						$date_range[$date1] = $date1;
				}
			}
		}
		asort($date_range); // old date first
		// generating date selection box
		$acount = count($date_range);
		$loopcount = 0;
		$start_date = "";
		$end_date = "";
		// $startcount = $acount - 7;
		// if($startcount < 0)
		$startcount = 0;
		$selbox_out_s = "<SELECT name='dateselbox_s' onChange='top.topFrame.frm1.dateselbox_s.value=this.value;'>\n";
		foreach($date_range as $key => $val) // from selection box
		{
			if($loopcount == $startcount || $start_date == $val)
			{
				$start_date = $val;
				$selbox_out_s = $selbox_out_s . " <OPTION value='$val' SELECTED>$key</OPTION>\n";
			}
			else
				$selbox_out_s = $selbox_out_s . " <OPTION value='$val'>$key</OPTION>\n";
			$loopcount++;
		}
		$selbox_out_s = $selbox_out_s . "</SELECT>\n";
		arsort($date_range); // last date first
		$selbox_out_e = "<SELECT name='dateselbox_e' onChange='top.topFrame.frm1.dateselbox_e.value=this.value;'>\n";
		foreach($date_range as $key => $val) // to selection box
		{
			if($end_date == "")
				$end_date = $val;
			if($end_date == $val)
				$selbox_out_e = $selbox_out_e . " <OPTION value='$val' SELECTED>$key</OPTION>\n";
			else
				$selbox_out_e = $selbox_out_e . " <OPTION value='$val'>$key</OPTION>\n";
		}
		$selbox_out_e = $selbox_out_e . "</SELECT>\n";
		echo "Set date range: from " . $selbox_out_s . " to " . $selbox_out_e;
	}

	function genHitoMeter($filename,$mode) // mode 4 dirs 5 files
	{
		$fpath = generateLogPath($filename);
		$total_input_size = 0; // total input traffic in bytes
		$total_output_size = 0; // total input traffic in bytes
		$date_range = array();
		$popularpaths_dl = array();
		$popularpaths_dlsize = array();
		$popularpaths_ul = array();
		$popularpaths_ulsize = array();
		$stime = time();
		$lines = file($fpath);
		$linecount = 0;
		foreach($lines as $line_num => $line)
		{
			$linecount++;
			$line = trim($line);
			$tokens = csv_explode(" ",$line);
			$vald = substr($tokens[3],0,10);
			if(isset($_REQUEST['dateselbox_s']) == true && $_REQUEST['dateselbox_s'] != "")
				$start_date = $_REQUEST['dateselbox_s'];
			if(isset($_REQUEST['dateselbox_e']) == true && $_REQUEST['dateselbox_e'] != "")
				$end_date = $_REQUEST['dateselbox_e'];
			if(($vald >= $start_date && $vald <= $end_date) || (isset($start_date) == false && isset($end_date) == false))
			{
				$current_username = $tokens[1]; // username
				$garray = explode(",",$tokens[2]);
				if(count($garray) > 1)
					$current_group = $garray[0];  // group
				else
					$current_group = $tokens[2];  // group
				if($tokens[4] == "w") // make top uploaders
				{
					if(count($tokens) == 8)
					{
						if(is_numeric($tokens[6])) // input size in bytes
						{
							if($mode == 4)
								$basepath = dirname($tokens[5]); // path
							else if($mode == 5)
								$basepath = basename($tokens[5]); // file
							if($basepath == "\\")
								$basepath = "/";
							if(isset($popularpaths_ul[$basepath]) == false)
								$popularpaths_ul[$basepath] = 1;
							else
								$popularpaths_ul[$basepath]++;
							if(isset($popularpaths_ulsize[$basepath]) == false)
								$popularpaths_ulsize[$basepath] = $tokens[6];
							else
								$popularpaths_ulsize[$basepath] = $popularpaths_ulsize[$basepath] + $tokens[6];
						}
					}
				}
				else if($tokens[4] == "r") // input traffic
				{
					if(count($tokens) == 8)
					{
						if(is_numeric($tokens[6])) // output size in bytes
						{
							if($mode == 4)
								$basepath = dirname($tokens[5]); // path
							else if($mode == 5)
								$basepath = basename($tokens[5]); // file
							if($basepath == "\\")
								$basepath = "/";
							if(isset($popularpaths_dl[$basepath]) == false)
								$popularpaths_dl[$basepath] = 1;
							else
								$popularpaths_dl[$basepath]++;
							if(isset($popularpaths_dlsize[$basepath]) == false)
								$popularpaths_dlsize[$basepath] = $tokens[6];
							else
								$popularpaths_dlsize[$basepath] = $popularpaths_dlsize[$basepath] + $tokens[6];
						}
					}
				}
			}
		}
		$etime = time();
		$str_lines               = "Total lines in LOG file: " . $linecount;
		$str_time_taken          = "Time taken for analysis: " . ($etime - $stime) . " second(s)";
		$str_size_logfile        = "Size of LOG file: " . byte_format(filesize($fpath));
		$output = '<div class="info">' . $str_lines . '<br>' . $str_time_taken . '<br>' . $str_size_logfile . '</div>';
		echo $output;
		arsort($popularpaths_dl);
		$counter = 0;
		if($mode == 4)
			$itemname = "folders";
		else if($mode == 5)
			$itemname = "files";
		echo "<h2>The most popular $itemname by downloading requests</h2>";
		echo '<table id="grid1" class="grid" border=0 cellspacing=0 cellpadding=0><thead><tr><td width=50>No.</td><td>Filename</td><td width=100>Count</td></tr></thead><tbody>';
		foreach($popularpaths_dl as $key => $val)
		{
			$counter++;
			if($counter == 1 || $counter == 2 || $counter == 3)
				$itag = "<div class='medal$counter'></div>";
			else
				$itag = "<div class='rank'>$counter</div>";
		  echo "<tr><td>$itag</td><td><div class='path'>$key</div></td><td>$val file downloads</td></tr>";
			if($counter >= 25)
				break;
		}
		echo '</tbody></table>';
		arsort($popularpaths_dlsize);
		$counter = 0;
		echo "<h2>The most popular $itemname by downloading size</h2>";
		echo '<table id="grid2" class="grid" border=0 cellspacing=0 cellpadding=0><thead><tr><td width=50>No.</td><td>Filename</td><td width=100>Size</td></tr></thead><tbody>';
		foreach($popularpaths_dlsize as $key => $val)
		{
			$counter++;
			if($counter == 1 || $counter == 2 || $counter == 3)
				$itag = "<div class='medal$counter'></div>";
			else
				$itag = "<div class='rank'>$counter</div>";
			echo "<tr><td>$itag</td><td><div class='path'>$key</p></td><td>" . byte_format($val) . "</td></tr>";
			//echo $counter . ". " . $key . " " . byte_format($val) . "<BR>";
			if($counter >= 25)
				break;
		}
		echo '</tbody></table>';
		arsort($popularpaths_ul);
		$counter = 0;
		echo "<h2>The most popular $itemname by uploading attempts</h2>";
		echo '<table id="grid3" class="grid" border=0 cellspacing=0 cellpadding=0><thead><tr><td width=50>No.</td><td>Filename</td><td width=100>Count</td></tr></thead><tbody>';
		foreach($popularpaths_ul as $key => $val)
		{
			$counter++;
			if($counter == 1 || $counter == 2 || $counter == 3)
				$itag = "<div class='medal$counter'></div>";
			else
				$itag = "<div class='rank'>$counter</div>";
			echo "<tr><td>$itag</td><td><div class='path'>$key</p></td><td>$val file uploads</td></tr>";
			// echo $counter . ". " . $key . " " . $val . " file uploads<BR>";
			if($counter >= 25)
				break;
		}
		echo '</tbody></table>';
		arsort($popularpaths_ulsize);
		$counter = 0;
		echo "<h2>The most popular $itemname by uploading size</h2>";
		echo '<table id="grid4" class="grid" border=0 cellspacing=0 cellpadding=0><thead><tr><td width=50>No.</td><td>Filename</td><td width=100>Size</td></tr></thead><tbody>';
		foreach($popularpaths_ulsize as $key => $val)
		{
			$counter++;
			if($counter == 1 || $counter == 2 || $counter == 3)
				$itag = "<div class='medal$counter'></div>";
			else
				$itag = "<div class='rank'>$counter</div>";
			echo "<tr><td>$itag</td><td><div class='path'>$key</p></td><td>" . byte_format($val) . "</td></tr>";
			// echo $counter . ". " . $key . " " . byte_format($val) . "<BR>";
			if($counter >= 25)
				break;
		}
		echo '</tbody></table>';
	}

	function createChart($op,$arro,$arri,$dates)
	{
		header("Content-type: image/png");
		$maxYval = 0;
		$xAxisTitle = "hour of day";
		$sysroot = getenv("SystemRoot");
		$font = $sysroot . "\\fonts\\" . 'segoeui.ttf';
		if(file_exists($font) == false)
			$font = $sysroot . "\\fonts\\" . 'arial.ttf';
		if($op == "spdchart")
		{
			$yAxisTitle1 = "Speed";
			$yAxisTitle2 = "";
			$topTitle = "Speed chart of $dates Red line: upload speed, Green line: download speed";
		}
		else if($op == "trafficchart" || isset($op) == false)
		{
			$yAxisTitle1 = "Traffic";
			$yAxisTitle2 = "";
			$topTitle = "Traffic chart of $dates Red line: upload traffic, Green line: download traffic";
		}
		$line_y_base = 460;
		$line_x_base = 60;
		$im = @imagecreatetruecolor(640,480) or die("Cannot Initialize new GD image stream");
		imageantialias($im,true);
		$background_color = imagecolorallocate($im,245,230,240);
		imagefill($im,0,0,$background_color);
		$text_color = imagecolorallocate($im,10,14,91);
		$title_color = imagecolorallocate($im,0,0,0);
		$dash_color = imagecolorallocate($im,140,200,200);
		$border_t = imagecolorallocate($im,200,200,200);;
		$border_d = imagecolorallocate($im,160,102,120);;
		$border_l = imagecolorallocate($im,190,200,200);;
		$border_r = imagecolorallocate($im,140,160,120);;
		$style = array($dash_color,$dash_color,$background_color,$background_color,$dash_color,$dash_color,$background_color,$background_color);
		$baseline_color = imagecolorallocate($im,0,0,5);
		$line_color1 = imagecolorallocate($im,0,241,0);
		$line_color2 = imagecolorallocate($im,255,5,0);
		//imagestring($im,1,10,5,$topTitle,$text_color);
		imagettftext($im,9,0,10,15,$text_color,$font,$topTitle);
		imageline($im,60,20,60,460,$baseline_color);
		imageline($im,0,0,639,0,$border_t);
		imageline($im,0,479,639,479,$border_d);
		imageline($im,0,0,0,479,$border_l);
		imageline($im,639,0,639,479,$border_r);
		imagettftext($im,9,0,560,473,$title_color,$font,$xAxisTitle);
		imagettftext($im,8,0,10,30,$title_color,$font,$yAxisTitle1);
		imagettftext($im,8,0,10,45,$title_color,$font,$yAxisTitle2);
		//	imagestring($im,1,565,462,$xAxisTitle,$title_color);
		//	imagestring($im,1,10,20,$yAxisTitle1,$title_color);
		//	imagestring($im,1,10,40,$yAxisTitle2,$title_color);
		$arr0 = explode(",",$arro);
		foreach($arr0 as $key => $val)
		{
			$arr1 = explode(":",$val);
			if(count($arr1) == 2)
			{
				if($arr1[0] >= 0 && $arr1[0] <= 23)
				{
					$arr_out[$arr1[0]] = $arr1[1];
					if($arr1[1] > $maxYval)
						$maxYval = $arr1[1];
				}
			}
		}
		$arr0 = explode(",",$arri);
		foreach($arr0 as $key => $val)
		{
			$arr1 = explode(":",$val);
			if(count($arr1) == 2)
			{
				if($arr1[0] >= 0 && $arr1[0] <= 23)
				{
					$arr_in[$arr1[0]] = $arr1[1];
					if($arr1[1] > $maxYval)
						$maxYval = $arr1[1];
				}
			}
		}
		for($i=0;$i<24;$i++)
		{
			imagettftext($im,8,0,58+$i*20,473,$text_color,$font,$i);
			//		imagestring($im,1,60+$i*20,462,$i,$text_color);
		}
		for($i=0;$i<=10;$i++)
		{
			$ySlice = $maxYval/10;
			$txt = sprintf("%d",$ySlice*$i);
			if($op == "spdchart")
				$txt = $txt . "k";
			else if($op == "trafficchart")
				$txt = byte_format($txt);
			if($i > 0)
			{
				imagettftext($im,8,0,10,464-(40*$i),$text_color,$font,$txt);
				// imagestring($im,1,10,456-(40*$i),$txt,$text_color);
				imageline($im,61,460-(40*$i),620,460-(40*$i),$dash_color);
			}
		}
		$lastx = $line_x_base;
		$lasty = $line_y_base;
		for($i=0;$i<24;$i++) // draw line
		{
			$i = sprintf("%02d",$i);
			if(isset($arr_out[$i]) == false || $arr_out[$i] == 0)
				$arr_out[$i] = 0;
			else
				$arr_out[$i] = 400 * ($arr_out[$i]/$maxYval);
			imageline($im,$lastx,$lasty,$line_x_base+$i*20,$line_y_base-$arr_out[$i],$line_color1);
			$lastx = $line_x_base+$i*20;
			$lasty = $line_y_base-$arr_out[$i];
		}
		imageline($im,$lastx,$lasty,$lastx,$line_y_base,$line_color1); // drop to zero
		$lastx = $line_x_base;
		$lasty = $line_y_base;
		for($i=0;$i<24;$i++) // draw line
		{
			$i = sprintf("%02d",$i);
			if(isset($arr_in[$i]) == false || $arr_in[$i] == 0)
				$arr_in[$i] = 0;
			else
				$arr_in[$i] = 400 * ($arr_in[$i]/$maxYval);
			imageline($im,$lastx,$lasty,$line_x_base+$i*20,$line_y_base-$arr_in[$i],$line_color2);
			$lastx = $line_x_base+$i*20;
			$lasty = $line_y_base-$arr_in[$i];
		}
		imageline($im,$lastx,$lasty,$lastx,$line_y_base,$line_color2); // drop to zero
		imageline($im,60,460,620,460,$baseline_color); // overwrite bottom line again
		imagepng($im);
		imagedestroy($im);
	}

	if(isset($_SESSION['logon_user']) == false)
		die("Not logged in");
	if(isset($_REQUEST['op']) == true)
		$op = $_REQUEST['op'];
	else
		$op = "";
	if(isset($_REQUEST['param1']) == true)
		$p1 = rawurldecode($_REQUEST['param1']);
	else
		$p1 = "";
	if(isset($_REQUEST['param2']) == true)
		$p2 = rawurldecode($_REQUEST['param2']);
	else
		$p2 = "";
	if(isset($_REQUEST['param3']) == true)
		$p3 = rawurldecode($_REQUEST['param3']);
	else
		$p3 = "";

	if($op == "trafficgraph")
	{
		genTrafficGraph($p1);
	}
	else if($op == "topstatistics")
	{
		genTopstatistics($p1);
	}
	else if($op == "daterange")
	{
		queryDateRange($p1);
	}
	else if($op == "hitometer")
	{
		genHitoMeter($p1,$p2);
	}
	else if($op == "showoperation")
	{
		genLogList($p1,$p2);
	}
	else if($op == "usage")
	{
		genUsage($p1,$p2);
	}
	else if($op == "spdchart" || $op == "trafficchart")
	{
		createChart($op,$p1,$p2,$p3);
	}
?>